﻿
-- My Garrison is Done --
-- Written by Jaxom of Hellfire --
-- Based on an Idea by Cederra of Hellfire, He helps test my addons and this was his idea. --
-- GNU General Public License version 3 (GPLv3) --

local GarrisonDone = ...

GarrisonDone_Version = GetAddOnMetadata("GarrisonDone", "Version")

    -- DEFAULTS --

local playerName = UnitName("player");
local character = UnitName("player").."-"..GetRealmName();
local playerID = UnitGUID;
local faction = UnitFactionGroup("player")
local self = GarrisonDone;
local toon = character:match("([^-]+)")
local DCF = DEFAULT_CHAT_FRAME;
local MISSION_PAGE_FRAME;



local waitTable = {};
local waitFrame = nil;

        -- Timer Function --
function GarrisonDone_Wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end

    -- ON LOAD --

function GarrisonDone_OnLoad(self)

    
    -- START --
        -- Assign Tabs for second Tab to show alts --
        PanelTemplates_SetNumTabs(GarrisonDoneFrame, 3);  -- 3 = frames total. --
        PanelTemplates_SetTab(GarrisonDoneFrame, 1);      -- 1 = tab 1 selected. --
        GarrisonDoneEditFrame:Show();
        GarrisonDoneAltsFrame:Hide();
        GarrisonDoneOptEditFrame:Hide();
        
        
    -- LOCK FRAME SIZE SETTINGS --
        
        GarrisonDoneFrame:SetMinResize(195,245);
        GarrisonDoneFrame:SetMaxResize(195,245);
        
        -- REGISTER EVENTS --
        -- Main frame --

        GarrisonDoneFrame:RegisterEvent("VARIABLES_LOADED")
        GarrisonDoneFrame:RegisterEvent("REGISTERFORDRAG")
        GarrisonDoneFrame:RegisterEvent("STORETEXT")
        GarrisonDoneFrame:RegisterEvent("ONTEXTCHANGED")
        GarrisonDoneFrame:RegisterEvent("UPDATE")
        GarrisonDoneFrame:RegisterEvent("GETTEXT")
        GarrisonDoneFrame:RegisterEvent("SETTEXT")
        GarrisonDoneFrame:RegisterEvent("ONSHOW")
        GarrisonDoneFrame:RegisterEvent("ONHIDE")
        GarrisonDoneFrame:RegisterEvent("ONCLICK")
        GarrisonDoneFrame:RegisterEvent("ZONE_CHANGED")
        GarrisonDoneFrame:RegisterEvent("ZONE_CHANGED_INDOORS")
        GarrisonDoneFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
        GarrisonDoneFrame:RegisterEvent("GARRISON_UPDATE")
        GarrisonDoneFrame:RegisterEvent("CHAT_MSG_SYSTEM")
        GarrisonDoneFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
        GarrisonDoneFrame:RegisterEvent("LOOT_CLOSED")
        GarrisonDoneFrame:RegisterEvent("ADDON_LOADED")
        GarrisonDoneFrame:RegisterEvent("PLAYER_LOGIN")
        GarrisonDoneFrame:RegisterEvent("PLAYER_LOGOUT")
        GarrisonDoneFrame:RegisterEvent("GARRISON_FOLLOWER_ADDED")
        GarrisonDoneFrame:RegisterEvent("GARRISON_FOLLOWER_LIST_UPDATE")
        GarrisonDoneFrame:RegisterEvent("GARRISON_FOLLOWER_REMOVED")
        GarrisonDoneFrame:RegisterEvent("GARRISON_HIDE_LANDING_PAGE")
        GarrisonDoneFrame:RegisterEvent("GARRISON_SHOW_LANDING_PAGE")
        GarrisonDoneFrame:RegisterEvent("GARRISON_USE_PARTY_GARRISON_CHANGED")
        GarrisonDoneFrame:RegisterEvent("GARRISON_MISSION_FINISHED")
        GarrisonDoneFrame:RegisterEvent("GARRISON_MISSION_COMPLETE_RESPONSE")
        GarrisonDoneFrame:RegisterEvent("GARRISON_MISSION_LIST_UPDATE")
        GarrisonDoneFrame:RegisterEvent("TAXIMAP_OPENED")
        GarrisonDoneFrame:RegisterEvent("PLAYER_LEAVING_WORLD")
        
	    table.insert(UISpecialFrames,"GarrisonDoneFrame");     
        
        -- SLASH COMMANDS --
        
        SlashCmdList["GARRISONDONE"] = function(sMsg)
			GarrisonDone_Slash_Command(sMsg)
		end
		SLASH_GARRISONDONE1 = "/mgd";
        SLASH_GARRISONDONE2 = "/gdone";
        
        GarrisonDone_Wait(30, GarrisonDone_Loaded(self, event))
end
 
-- C_Timer.After(30, function() GarrisonDone_Loaded(self, event, ...) end)           
    
        -- Set Default Variables --
function GarrisonDone_Loaded(self, event, ...)
        if (event == "VARIABLES_LOADED") then
        if GarrisonDone_Varsc == nil then
            GarrisonDone_Varsc = GarrisonDone_defaults
        end
        if not GarrisonDone_Varsc["version"] then
            GarrisonDone_Varsc["version"] = GarrisonDone_Version;
        end
        if not GarrisonDone_Vars[GetRealmName()] then
			GarrisonDone_Vars[GetRealmName()] = {}
		end
		if not GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] then
			GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] = {}
	    end
    end
end
   
   
        -- Load Variables and fire it up :) --
function GarrisonDone_OnEvent(self, event, ...)
        if event == "PLAYER_ENTERING_WORLD" then
            
        GarrisonDone_Varsc.version = GarrisonDone_Varsc.version;
		if GarrisonDone_Varsc.version == "nil" then
			GarrisonDone_Varsc.version = GarrisonDone_Version;
        elseif GarrisonDone_Varsc.version < GarrisonDone_Version then
            GarrisonDone_Varsc.version = GarrisonDone_Version;
		end
            -- Last Login to creat timer for reset --
        GarrisonDone_Varsc.lastLogin = GarrisonDone_Varsc.lastLogin;
		if GarrisonDone_Varsc.lastLogin == "nil" then
        GarrisonDone_Varsc.lastLogin = ""
        end
            -- Last Logout to creat timer for reset --
        GarrisonDone_Varsc.lastLogout = GarrisonDone_Varsc.lastLogout;
		if GarrisonDone_Varsc.lastLogout == "nil" then
        GarrisonDone_Varsc.lastLogout = ""
        end
            -- How many Nodes left to Mine --
        GarrisonDone_Varsc.miningLeft = tonumber(GarrisonDone_Varsc.miningLeft);
		if GarrisonDone_Varsc.miningLeft == "nil" then
			GarrisonDone_Varsc.miningLeft = ""
		end
            -- Max Mining based on Mine LvL --
        GarrisonDone_Varsc.maxMining = tonumber(GarrisonDone_Varsc.maxMining);
		if GarrisonDone_Varsc.maxMining == "nil" then
			GarrisonDone_Varsc.maxMining = ""
		end
            -- How many herbs still to pick --
        GarrisonDone_Varsc.herbingLeft = tonumber(GarrisonDone_Varsc.herbingLeft);
		if GarrisonDone_Varsc.herbingLeft == "nil" then
			GarrisonDone_Varsc.herbingLeft = ""
		end
            -- Max Herbing based on garden LvL --
        GarrisonDone_Varsc.maxHerbing = tonumber(GarrisonDone_Varsc.maxHerbing);
		if GarrisonDone_Varsc.maxHerbing == "nil" then
			GarrisonDone_Varsc.maxHerbing = ""
		end        
		    -- Here in case i need a refrence table --
		GarrisonDone_Varsc.reference = GarrisonDone_Varsc.reference;
		if GarrisonDone_Varsc.refrence == "nil" then
			GarrisonDone_Varsc.reference = ""
		end
            -- Do you have a Garrison --
        GarrisonDone_Varsc.hasGarrison = GarrisonDone_Varsc.hasGarrison;
		if GarrisonDone_Varsc.hasGarrison == "nil" then
			GarrisonDone_Varsc.hasGarrison = ""
		end
            -- Start/Stop Print Timer --
        GarrisonDone_Varsc.disptimer = GarrisonDone_Varsc.disptimer;
		if GarrisonDone_Varsc.disptimer == "nil" then
			GarrisonDone_Varsc.disptimer = ""
		end
            -- Hide /Show Variable for Auto Show --
        GarrisonDone_Varsc.auto = GarrisonDone_Varsc.auto;
		if GarrisonDone_Varsc.auto == "nil" then
		GarrisonDone_Varsc.auto = not(GarrisonDone_Varsc.auto)
        end
            -- Hide /Show Variable for Floating Button --        
        GarrisonDone_Varsc.button = GarrisonDone_Varsc.button; 
		if GarrisonDone_Varsc.button == "nil" then
		GarrisonDone_Varsc.button = not(GarrisonDone_Varsc.button)
        end 
            -- ON /OFF Variable for Audible Warning --        
        GarrisonDone_Varsc.warning = GarrisonDone_Varsc.warning; 
		if GarrisonDone_Varsc.warning == "nil" then
	    GarrisonDone_Varsc.warning = not(GarrisonDone_Varsc.warning)
		end
            -- ON /OFF Variable for Manual Frame Control --        
        GarrisonDone_Varsc.manual = GarrisonDone_Varsc.manual; 
		if GarrisonDone_Varsc.manual == "nil" then
	    GarrisonDone_Varsc.manual = not(GarrisonDone_Varsc.manual)
		end
            -- Hide/Show /OFF Variable for Manual Frame Control --        
        GarrisonDone_Varsc.minimap = GarrisonDone_Varsc.minimap; 
		if GarrisonDone_Varsc.minimap == "nil" then
	    GarrisonDone_Varsc.minimap = {
            hide = true;
            }
        elseif (event=="GARRISON_MISSION_FINISHED") then
		    GarrisonDone_UpdateData()
	    elseif (event == "GARRISON_MISSION_COMPLETE_RESPONSE") then
		    GarrisonDone_Cleanup()
	    elseif (event == "GARRISON_MISSION_LIST_UPDATE") then
		    GarrisonDone_UpdateData()
        end
    --    GarrisonDone_CompLogin(toon, when);
    end
end	

    
        -- Check if player is lvl 90 --
function GarrisonDone_HasGarrison(self, event, ...)
        local level = UnitLevel("player")
        if event == "ADDON_LOADED" then
	    if level >= 90 and (IsQuestFlaggedCompleted(34586) or IsQuestFlaggedCompleted(34378)) then
		    GarrisonDone_Varsc.hasGarrison = true
        end
        elseif level < 90 then GarrisonDone_Varsc.hasGarrison = false
        GarrisonDone_ShutDown(self, ShutDown);
    end
end
  
        -- Not Level 90 or has not Unlocked Garrison --
function GarrisonDone_ShutDown(self, ShutDown)
        if GarrisonDone_Varsc.hasGarrison == false then        
        GarrisonDoneFrame:UnregisterEvent("VARIABLES_LOADED")
        GarrisonDoneFrame:UnregisterEvent("REGISTERFORDRAG")
        GarrisonDoneFrame:UnregisterEvent("STORETEXT")
        GarrisonDoneFrame:UnregisterEvent("ONTEXTCHANGED")
        GarrisonDoneFrame:UnregisterEvent("UPDATE")
        GarrisonDoneFrame:UnregisterEvent("GETTEXT")
        GarrisonDoneFrame:UnregisterEvent("SETTEXT")
        GarrisonDoneFrame:UnregisterEvent("ONSHOW")
        GarrisonDoneFrame:UnregisterEvent("ONHIDE")
        GarrisonDoneFrame:UnregisterEvent("ONCLICK")
        GarrisonDoneFrame:UnregisterEvent("ZONE_CHANGED")
        GarrisonDoneFrame:UnregisterEvent("ZONE_CHANGED_INDOORS")
        GarrisonDoneFrame:UnregisterEvent("ZONE_CHANGED_NEW_AREA")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_UPDATE")
        GarrisonDoneFrame:UnregisterEvent("CHAT_MSG_SYSTEM")
        GarrisonDoneFrame:UnregisterEvent("PLAYER_ENTERING_WORLD")
        GarrisonDoneFrame:UnregisterEvent("UNIT_SPELLCAST_START")
        GarrisonDoneFrame:UnregisterEvent("UNIT_SPELLCAST_STOP")
        GarrisonDoneFrame:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
        GarrisonDoneFrame:UnregisterEvent("LOOT_CLOSED")
        GarrisonDoneFrame:UnregisterEvent("ADDON_LOADED")
        GarrisonDoneFrame:UnregisterEvent("PLAYER_LOGIN")
        GarrisonDoneFrame:UnregisterEvent("PLAYER_LOGOUT")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_FOLLOWER_ADDED")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_FOLLOWER_LIST_UPDATE")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_FOLLOWER_REMOVED")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_HIDE_LANDING_PAGE")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_SHOW_LANDING_PAGE")
        GarrisonDoneFrame:UnregisterEvent("GARRISON_USE_PARTY_GARRISON_CHANGED")
        GarrisonDoneFrame:UnregisterEvent("TAXIMAP_OPENED")
--        MGD_Button:Hide();
        GarrisonDoneFrame:Hide();
        DisableAddOn("GarrisonDone");
        DEFAULT_CHAT_FRAME:AddMessage("|cffff0000You do not have A Garrison, |cfffeef02Disabling Addon")
        else
        return
    end    
end

  
        -- Is Player in there Garrison, if yes auto Open --
function GarrisonDone_FrameAuto(self, event, ...)
        local playerName = UnitName("player");
        local mapID = GetCurrentMapAreaID();
        local mapname = GetMapNameByID(mapID);
        local zoneName = GetSubZoneText();
        local zoneText = GetMinimapZoneText();
        
        if event == "ZONE_CHANGED" then
            
                -- Alliance --
			if (zoneText == (""..playerName.."'s Garrison") and GarrisonDone_Varsc.auto == true) or zoneText == "Town Hall" then
			GarrisonDoneFrame:Show();
            PanelTemplates_SetTab(GarrisonDoneFrame, 1);
            GarrisonDoneEditFrame:Show();
            GarrisonDoneAltsFrame:Hide();
            GarrisonDoneOptEditFrame:Hide();
            elseif (mapname ~= "Lunarfall" and GarrisonDone_Varsc.manual == false) then
			GarrisonDoneFrame:Hide();
            
                -- Horde --
			elseif (zoneText == (""..playerName.."'s Fort") and GarrisonDone_Varsc.auto == true) or zoneText == "Town Hall" then
			GarrisonDoneFrame:Show();
            PanelTemplates_SetTab(GarrisonDoneFrame, 1);
            GarrisonDoneEditFrame:Show();
            GarrisonDoneAltsFrame:Hide();
            GarrisonDoneOptEditFrame:Hide();
            elseif (mapname ~= "Frostwall" and GarrisonDone_Varsc.manual == false) then
			GarrisonDoneFrame:Hide();
        end
    end
end
 
            -- No Misions in Progress Game Menu Warning --
function GarrisonDone_GameMenu(self, GameMenuFrame)
        local completeMissions = C_Garrison.GetCompleteMissions();
        local items = C_Garrison.GetLandingPageItems();  
        local mip = #items - #completeMissions;
        if mip == 0 then
        if GameMenuFrame_UpdateVisibleButtons then
			hooksecurefunc("GameMenuFrame_UpdateVisibleButtons", function()
			GameMenuFrame:SetHeight(GameMenuFrame:GetHeight() + 25)
					end)
				end
			local point, relativeTo, relativePoint, x, y = GameMenuButtonQuit:GetPoint(1)
				if (relativeTo and relativeTo ~= self) then
					self:SetPoint(point, relativeTo, relativePoint, x, y)
			end
			GameMenuButtonQuit:ClearAllPoints()
		    GameMenuButtonQuit:SetPoint("TOP", self, "BOTTOM", 0, - 1)
    end
end

function GarrisonDone_GameMenuHide(self, GameMenuFrame)
        local completeMissions = C_Garrison.GetCompleteMissions();
        local items = C_Garrison.GetLandingPageItems();  
        local mip = #items - #completeMissions;
        if mip ~= 0 then
        MGDGameMenu:Hide()
    end
end

            -- No Misions in Progress Flight Path Warning --
function GarrisonDone_WarningFp(self, event, ...)
        local completeMissions = C_Garrison.GetCompleteMissions();
        local items = C_Garrison.GetLandingPageItems();  
        local mip = #items - #completeMissions;
    if event == "TAXIMAP_OPENED" then
        if mip == 0 then
            GarrisonDoneFrame:Show();
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            PlaySound("RaidWarning", "Master")
        end
    end
end
              -- No Misions in Progress Zone Change Warning --        
function GarrisonDone_WarningZc(self, event, ...)     
    if event == "ZONE_CHANGED" then
        local completeMissions = C_Garrison.GetCompleteMissions();
        local items = C_Garrison.GetLandingPageItems();  
        local mip = #items - #completeMissions;
        local mapID = GetCurrentMapAreaID();
        local mapname = GetMapNameByID(mapID);
        local zone = GetCurrentMapZone();
        local zoneName = GetSubZoneText();
        local zoneText = GetMinimapZoneText();
        local faction = UnitFactionGroup("player")
          
                -- Alliance --
        if faction == "Alliance" then
	    if (zoneName == (""..playerName.."'s Garrison") or zoneText == (""..playerName.."'s Garrison")) then
            if mip == 0 then
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
                end           
            end
        end
               -- Horde --
        elseif faction == "Horde" then
	    if (zoneName == (""..playerName.."'s Fort") or zoneText == (""..playerName.."'s Fort"))  then
        if mip == 0 then
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
    --            end
            end
        end
    end
        elseif mip ~= 0 then 
            return
        end
    end
end
        
        
        -- No Misions in Progress Draenor Zone Warning --
function GarrisonDone_WarnZone(self, event, ...)
        if event == "ZONE_CHANGED_NEW_AREA" then
        local completeMissions = C_Garrison.GetCompleteMissions();
        local items = C_Garrison.GetLandingPageItems();  
        local mip = #items - #completeMissions;
        local mapID = GetCurrentMapAreaID();
        local mapname = GetMapNameByID(mapID);
        local zone = GetCurrentMapZone();
        local faction = UnitFactionGroup("player")
        
        if mip == 0 then
        if faction == "Alliance" then    
        if mapID == 947 then -- Shadowmoon Valley
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Garrison")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end        
        elseif mapID == 941 then -- Frostfire Ridge
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Highpass")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 949 then -- Gorgrond
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Highpass")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 946 then -- Talador
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Fort Wrynn")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 948 then -- Spires of Arak
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Southport")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 950 then -- Nagrand
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Telaari Station")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 978 then -- Ashran
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Garrison")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 945 then -- Tanaan Jungle
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933UnKnown")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        end
        
                                                    -- Find HORDE OUTPOSTS --
        elseif faction == "Horde" then
        if mapID == 947 then -- Shadowmoon Valley
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Fort")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 941 then -- Frostfire Ridge
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Fort")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 949 then -- Gorgrond
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Fort")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 946 then -- Talador
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Fort")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 948 then -- Spires of Arak
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Outpost at Axefall")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 950 then -- Nagrand
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Fort")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 978 then -- Ashran
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933Your Fort")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
            end  
        elseif mapID == 945 then -- Tanaan Jungle
            DEFAULT_CHAT_FRAME:AddMessage("|cffff0000WARNING|r you have |cffff0000NO|cfffeef02 Missions In Progress")
            DEFAULT_CHAT_FRAME:AddMessage("|cfffeef02Your Nearest Mission Table is |cff009933UnKnown")
            if GarrisonDone_Varsc.warning == true then
            PlaySound("RaidWarning", "Master")
                    end  
                end
            end
        end
    end
end
   
            
            
            -- Open on Mission Window Close --
function GarrisonDone_MissionFrame(self)
    local MISSION_PAGE_FRAME = GarrisonMissionFrame
        if GarrisonMissionFrame:IsShown() then
            MGDMissionsTab:Show();
    end
end


function GarrisonDone_MissionsOpen(self)
        if GarrisonMissionPage_Close() == true then
            GarrisonDoneFrame:Show();
    end
end
  
            
           -- Delay Counter for Spell Casts -- 
C_Timer.After(20, function() GarrisonDone_CounterEvents(self, elapsed) end)


   
        -- BEGIN COUNT DOWN HERBS AND ORE --   
function GarrisonDone_CounterEvents(self, elapsed)
        GarrisonDoneFrame:RegisterEvent("UNIT_SPELLCAST_START")
        GarrisonDoneFrame:RegisterEvent("UNIT_SPELLCAST_STOP")
        GarrisonDoneFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
end
            
         -- Count Ore --
function GarrisonDone_CountOre(self, event, ...)
        if event == "UNIT_SPELLCAST_START" then
        local unit, spell = ...
		if (unit == "player" and spell == "Mining") then
            return
        end
        elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
            local unit, spell = ...
		if (unit == "player" and spell == "Mining") then
            GarrisonDone_OreCounter(self, GarrisonDone_CountOre);
            end
        end
        if event == "UNIT_SPELLCAST_START" then
            local unit, spell = ...
		if ((spell == "Herbalism" or spell == "Herb Gathering") and unit == "player") then
            return
        end
        elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
            local unit, spell = ...
		if ((spell == "Herbalism" or spell == "Herb Gathering") and unit == "player") then
            GarrisonDone_HerbCount(self, GarrisonDone_CountHerbs);
        end
    end
end
            -- Now actually do the ore counter --
function GarrisonDone_OreCounter(self, GarrisonDone_CountOre)
        local zoneText = GetMinimapZoneText();
		local zoneName = GetSubZoneText();
		if (zoneName == "Lunarfall Excavation" or zoneName == "Frostwall Mine") or (zoneText == "Lunarfall Excavation" or zoneText == "Frostwall Mine") then
			GarrisonDone_Varsc.miningLeft = GarrisonDone_Varsc.miningLeft - 1;
            GarrisonDone_Update(self);
        DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20Were Mining") -- Debug --
    end
end
        
            -- Now actually do the herb counter --
function GarrisonDone_HerbCount(self, GarrisonDone_CountHerbs)
        local playerName = UnitName("player");
        local zoneText = GetMinimapZoneText();
		local zoneName = GetSubZoneText();
		if zoneText == (""..playerName.."'s Garrison") or zoneText == (""..playerName.."'s Fort") then  -- would still like this to be the garden --
			GarrisonDone_Varsc.herbingLeft = GarrisonDone_Varsc.herbingLeft - 1;
            GarrisonDone_Update(self);
        DEFAULT_CHAT_FRAME:AddMessage("|cff20ff20Were Herbing") -- Debug --
    end
end
            -- Un Register Count Events when were done --
function GarrisonDone_CountComplete(self)
    if (GarrisonDone_Varsc.herbingLeft == 0 and GarrisonDone_Varsc.miningLeft == 0)  then
        GarrisonDoneFrame:UnregisterEvent("UNIT_SPELLCAST_START")
        GarrisonDoneFrame:UnregisterEvent("UNIT_SPELLCAST_STOP")
        GarrisonDoneFrame:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
    end
end
        -- END ORE AND HERB COUNT SYSTEM --
        



        -- Set Old times based on logout so reset works --
function GarrisonDone_OnLogout(self, event, ...)        
    if event == "PLAYER_LOGOUT" then
        GarrisonDone_Varsc.lastLogout = {
			["time"] = time(),
			["resetTime"] = GetQuestResetTime(),
		}
    end
end
    
     
   
        -- SHOW FRAMES and Update --    
function GarrisonDone_OnShow(self)
    GarrisonDoneFrame:Show();
    PanelTemplates_SetTab(GarrisonDoneFrame, 1);
    if GarrisonDoneEditFrame:Show() == true then
        GarrisonDone_Update(self);
        GarrisonDoneAltsFrame:Hide();
        GarrisonDoneAltsScrollFrame:Hide();
        GarrisonDoneOptEditFrame:Hide();
    end
end  



 
        -- TOGGLES FRAME USEING SLASH COMMAND --
function GarrisonDone_Slash_Command(sMsg)
	if GarrisonDoneFrame:IsVisible() then
		GarrisonDoneFrame:Hide();
	else
		GarrisonDoneFrame:Show();
        GarrisonDoneEditFrame:Show();
        GarrisonDoneAltsFrame:Hide();
        GarrisonDoneAltsScrollFrame:Hide();
        GarrisonDoneOptEditFrame:Hide();
	end
end
  
        -- MOVES FRAME --
function GarrisonDone_OnMouseDown(self)
    if (IsShiftKeyDown() and Button == "Shift-RightButton") then
	    GarrisonDoneFrame:StartMoving();
    end
end
  
function GarrisonDone_OnMouseUp(self)
	if (IsShiftKeyDown() and Button == "Shift-RightButton") then
	GarrisonDoneFrame:StopMovingOrSizing();
	end
end
 
 
        -- FLOATING BUTTON --
function GarrisonDone_ShowMini(self, event, ...)
    if event == "PLAYER_ENTERING_WORLD" then
	if (GarrisonDone_Varsc.button == true) then
        MGDButton:Show();
        end
    elseif (GarrisonDone_Varsc.button ~= true) then
        MGDButton:Hide();
    end
end


        -- MGD Button Tooltip --
function MGDButton_OnEnter(MGDButton)
    GameTooltip:SetOwner(MGDButton, "ANCHOR_BOTTOMLEFT")
    GameTooltip:SetText("My Garrison is Done")
    GameTooltip:AddLine("Left Click to Open My Garrison", 1, 1, 1)
    GameTooltip:AddLine("Shift Right Click to Move", 1, 1, 1)
    GameTooltip:AddLine("Shift Right Click to Save Position", 1, 1, 1)
    GameTooltip:Show();
end

function MGDButton_OnLeave(MGDButton)
    GameTooltip:Hide()
end

      

        -- REMOVES FRAME IF DISABLE TRUE --
function GarrisonDone_MakeESCable(frame,disable)
	local idx
	for i=1,#(UISpecialFrames) do
		if UISpecialFrames[i]==frame then
			idx = i
			break
		end
	end
	if idx and disable then
		table.remove(UISpecialFrames,idx)
	elseif not idx and not disable then
		table.insert(UISpecialFrames,1,frame)
	end
end



 

        -- CURRENT PLAYER FRAME STARTS HERE --

function GarrisonDone_Update(self)
    -- Assign Local Variables straight from Blizz frame --
    
    
    -- Max Followers --
    local maxFollowers = C_Garrison.GetFollowerSoftCap();
    
    
    -- Active Followers --
    local numActiveFollowers = C_Garrison.GetNumActiveFollowers();
    
    
    -- Missions Available --
    local AvailableItems = C_Garrison.GetAvailableMissions();
    
    
    -- Missions Complete --
    local completeMissions = C_Garrison.GetCompleteMissions();
    
    -- Missions in Progress --
    local items = C_Garrison.GetLandingPageItems();  
    local mip = #items - #completeMissions;


    -- Mining Nodes --
    local ore = 0;
    if GarrisonDone_Varsc.hasMine == true then
		if GarrisonDone_Varsc.miningLeft > 0 then
		ore = format("%s", GarrisonDone_Varsc.miningLeft)
            tonumber(ore)
		end
    end
    local ores = 0;
    if GarrisonDone_Varsc.hasMine == true then
		if GarrisonDone_Varsc.maxMining > 0 then
		ores = format("%s", GarrisonDone_Varsc.maxMining)
            tonumber(ores)
		end
	end 
    
    
    -- Herb Nodes --
    local herb = 0;
    if GarrisonDone_Varsc.hasGarden == true then
    	if GarrisonDone_Varsc.herbingLeft > 0 then
		herb = format("%s", GarrisonDone_Varsc.herbingLeft)
            tonumber(herb)
		end
	end 
    local herbs = 0;
    if GarrisonDone_Varsc.hasGarden == true then
		if GarrisonDone_Varsc.maxHerbing > 0 then
		herbs = format("%s", GarrisonDone_Varsc.maxHerbing)
            tonumber(herbs)
		end
	end
    
    
        -- Find all our Followers and Set Status --
    local followers = C_Garrison.GetFollowers();
    
    -- Followers working --
    local work = 0;
    for i = 1, #followers do
	if ( followers[i].status == GARRISON_FOLLOWER_WORKING) then
		work = work + 1;
        end
    end
    -- Followers on Missions --
    local gfm = 0;
    for i = 1, #followers do
	if ( followers[i].status == GARRISON_FOLLOWER_ON_MISSION) then
		gfm = gfm + 1;
        end
    end
       
    local fBusy = gfm + work;
    local available = numActiveFollowers - fBusy;

        -- Garrison Resources --
    local _, currentAmount, _, _, _, _, _ = GetCurrencyInfo(824);

    
	-- Set Contents Main Frame --
	if (GarrisonDoneEditFrame:IsShown()) then
        -- Players Garrison --
		GarrisonDonePageName:SetText(""..playerName.."'s  Garrison");
        -- Max Followers --
		MGDTFPageName:SetText("|cffFF8000Total Followers|cff007fff = |r"..numActiveFollowers.."|cff007fff/|cffFF8000"..maxFollowers.."");
            if numActiveFollowers == 25 then
        MGDTFPageName:SetText("|cffFF8000Total Followers|cff007fff = |r|cff00aa00"..numActiveFollowers.."|cff007fff/|cffFF8000"..maxFollowers..""); 
            elseif numActiveFollowers > 25 then
        MGDTFPageName:SetText("|cffFF8000Total Followers|cff007fff = |r|cffff0000"..numActiveFollowers.."|cff007fff/|cffFF8000"..maxFollowers..""); 
            end
        -- Missions in Progress --
            if mip ~= 0 then
		MGDFMPageName:SetText("Missions in Progress|cff007fff = |cffffffff"..mip.."");
            elseif mip == 0 then
        MGDFMPageName:SetText("|cffffffffMissions in Progress|cff007fff = |r|cffff0000"..mip.."");
            end
        -- Complete Missions --
		MGDMCPageName:SetText("Missions Complete|cff007fff = |cff00aa00"..#completeMissions.."");
        -- Missions Available --
		MGDMAPageName:SetText("Missions Available|cff007fff = |r"..#AvailableItems.."");
        -- Followers Available --
		MGDFAPageName:SetText("Followers Available|cff007fff = |r"..available.."");
            if available == 0 then
        MGDFAPageName:SetText("Followers Available|cff007fff = |r|cff00aa00"..available.."");
            elseif available > 25 then
        MGDFAPageName:SetText("Followers Available|cff007fff = |r|cffff0000"..available.."");       
            end
        -- Followers Working
		MGDFWPageName:SetText("Followers Working|cff007fff = |r"..work.."");
        -- Followers on Mission
	    MGDFOMPageName:SetText("Out On A Mission|cff007fff = |cffFF8000"..gfm.."");
            if gfm == 0 then
        MGDFOMPageName:SetText("Followers on Mission|cff007fff = |cffff0000"..gfm.."");
            end
        -- Mining Nodes --
            if ore ~= 0 then
		MGDMNPageName:SetText("Mining Nodes|cff007fff = |cffff0000"..ore.."|cff007fff/|cff00aa00"..ores.."");
            elseif ore == 0 then
        MGDMNPageName:SetText("Mining Nodes|cff007fff = |r"..ore.."|cff007fff/|cff00aa00"..ores.."");
            end
        -- Herb Nodes --
            if herb ~= 0 then
		MGDHNPageName:SetText("Nice Flowers|cff007fff = |cffff0000"..herb.."|cff007fff/|cff00aa00"..herbs.."");
            elseif herb == 0 then
        MGDHNPageName:SetText("Nice Flowers|cff007fff = |r"..herb.."|cff007fff/|cff00aa00"..herbs.."");  
            end
        -- Garrison Resources --
		MGDGRPageName:SetText("Your Resources|cff007fff = |r"..currentAmount.."")
        -- Reset Game Menu without reload --
        GarrisonDone_GameMenuHide(self, GameMenuFrame);
    end
end

      
      
        
        -- ALTS MISSION FRAME STARTS HERE --
        -- Wrote this Part from about 3 different addons so My Gratefull Thanks to those who went before me --
        -- Most of the code was from Garrison Timer by Zaman, My Thanks and appreciation for his initial work --
   

local GarrisonDone_Update_Log = 0
local GarrisonDone_Update_Frequency = 120
local GarrisonDoneAltsFrame_Update_Log = 0
-- local GarrisonDoneAltsFrame_Update_Frequency = 1

local GarrisonDone_StartTime = 0
local maxBars = 13
local barList = {}
local unUsedBars = {}
local totalBars = 0

local tempSortedList = {}

local sortOrders = {
		{name = "Default", value = "default"},
    --    {name = "Character", value = "character"},
	--	{name = "Time", value = "time"},
	--	{name = "Is Rare" , value = "israre"}
		
	}
    
function GarrisonDone_DispTimer(self, elapsed)
    if GarrisonDone_Varsc.disptimer == true then
        C_Timer.After(1800, function() GarrisonDone_Display(self, elapsed) end)
        C_Timer.After(3600, function() GarrisonDone_Display(self, elapsed) end)
        C_Timer.After(5400, function() GarrisonDone_Display(self, elapsed) end)
        C_Timer.After(7200, function() GarrisonDone_Display(self, elapsed) end)
        C_Timer.After(9000, function() GarrisonDone_Display(self, elapsed) end)
        C_Timer.After(10800, function() GarrisonDone_Display(self, elapsed) end)
        C_Timer.After(12600, function() GarrisonDone_Display(self, elapsed) end)
        C_Timer.After(14400, function() GarrisonDone_Display(self, elapsed) end)
        C_Timer.After(16200, function() GarrisonDone_Display(self, elapsed) end)
        C_Timer.After(18000, function() GarrisonDone_Display(self, elapsed) end)
    elseif GarrisonDone_Varsc.disptimer ~= true then
        return
    end
end

            -- List Missions in DCF --
C_Timer.After(30, function() GarrisonDone_Display(self, elapsed) end)
function GarrisonDone_Display(self, elapsed)
    if not UnitAffectingCombat("player") then
	if GarrisonDone_Vars then
		for realm, v1 in pairs(GarrisonDone_Vars) do
			for character, v2 in pairs(v1) do
				for missionId, data in pairs(v2) do
					    local color = "|cffE6CC80"
					    -- Set Class Colors --
                        if data.isRare ~= true then 
                        if data.class == "Death Knight" then color = "|cffC41F3B"
                        elseif data.class == "Druid" then color = "|cffFF7D0A"
                        elseif data.class == "Hunter" then color = "|cffABD473"
                        elseif data.class == "Mage" then color = "|cff69CCF0"
                        elseif data.class == "Monk" then color = "|cff00FF96"
                        elseif data.class == "Paladin" then color = "|cffF58CBA"
                        elseif data.class == "Priest" then color = "|cffFFFFFF"
                        elseif data.class == "Rogue" then color = "|cffFFF569"
                        elseif data.class == "Shaman" then color = "|cff0070DE"
                        elseif data.class == "Warlock" then color = "|cff9482C9"
                        elseif data.class == "Warrior" then color = "|cffC79C6E"
                            end
                        end
                        -- Change to Rare Blue for Rare Missions --
					    if data.isRare == true then
                        if data.class == "Death Knight" then color = "|cff0070FFR |cffC41F3B"
                        elseif data.class == "Druid" then color = "|cff0070FFR |cffFF7D0A"
                        elseif data.class == "Hunter" then color = "|cff0070FFR |cffABD473"
                        elseif data.class == "Mage" then color = "|cff0070FFR |cff69CCF0"
                        elseif data.class == "Monk" then color = "|cff0070FFR |cff00FF96"
                        elseif data.class == "Paladin" then color = "|cff0070FFR |cffF58CBA"
                        elseif data.class == "Priest" then color = "|cff0070FFR |cffFFFFFF"
                        elseif data.class == "Rogue" then color = "|cff0070FFR |cffFFF569"
                        elseif data.class == "Shaman" then color = "|cff0070FFR |cff0070DE"
                        elseif data.class == "Warlock" then color = "|cff0070FFR |cff9482C9"
                        elseif data.class == "Warrior" then color = "|cff0070FFR |cffC79C6E"
                            end
                        end
					    if data.endTime < time() then
						    print(color..character.."-"..realm.." : |cffE6CC80"..data.name.." : |cff1EFF0Ccompleted")
					    else
						    print(color..character.."-"..realm.." : |cffE6CC80"..data.name.." : |cff00FAF6"..date("%H:%M",data.endTime))
					    end
				    end
			    end
		    end
	    end
    end
end


            -- rotate the bar frames so we dont waste resources --
function GarrisonDone_Rebuild()
	local template = "GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"
	for index, object in pairs(barList) do
		if string.find("GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_", index) then
			unUsedBars[#unUsedBars + 1] = object
			object.bar:Hide()
			barList[index] = nil
		end
	end
	GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] = {}
	GarrisonDone_UpdateData()
end

            -- Clean out old Missions --
function GarrisonDone_Cleanup()
	local missionsLeft = {}
	local updatePending = false
	local mt = C_Garrison.GetInProgressMissions()
	for index, v in ipairs(mt) do
		missionsLeft[#missionsLeft + 1] = v.missionID
	end
	if GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] then
		for j = #GarrisonDone_Vars[GetRealmName()][GetUnitName("player")], 1, -1 do
			local value = GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][j]
			local exists = false
			for i = 1,#missionsLeft,1 do
				if missionsLeft[i] == value.missionID then
					exists = true
				end
			end
			if not exists then
				tremove(GarrisonDone_Vars[GetRealmName()][GetUnitName("player")], j)
				if barList["GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"..value.missionID] then
					unUsedBars[#unUsedBars + 1] = barList["GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"..value.missionID]
					barList["GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"..value.missionID].bar:Hide()
					barList["GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"..value.missionID] = nil
					updatePending = true
				end
			end
		end
	end
	if updatePending then
		local i = 0
		if GarrisonDone_Vars then
			for id, object in pairs(barList) do
				object.bar:ClearAllPoints()
				object.bar:SetPoint("TOPLEFT", "GarrisonDoneAltsFrame", 30, -60-15*i)
				i = i + 1
			end
		end
	end
end

                -- Get the Missions and there times and save the variables --
function GarrisonDone_UpdateData(data)
	local mt = C_Garrison.GetInProgressMissions()
	for index, v in ipairs(mt) do
		if(type(v) == "table") then
			local newIndex = #GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] + 1
			local endTime = time()
			local num = select('#',strsplit(" ",v.timeLeft))
			local detailedTime = false
			for i = 1, num, 2 do
				local var = select(i,strsplit(" ",v.timeLeft))
				local unit = select(i+1,strsplit(" ",v.timeLeft))
				if(unit == "days") then
					endTime = endTime + var*24*3600
				elseif(unit == "hr") then
					endTime = endTime + var*3600
				elseif(unit == "min") then
					endTime = endTime + var*60
				elseif(unit == "sec") then
					endTime = endTime + var
					detailedTime = true
				end
			end
			if(data and data.missionID and data.missionID == v.missionID) then
				data.timeLeft = v.timeLeft
				data.endTime = endTime
				data.detailedTime = true
			elseif (not data) then
				if( not GarrisonDone_Vars) then
					GarrisonDone_Vars = {}
				end
				if (not GarrisonDone_Vars[GetRealmName()]) then
					GarrisonDone_Vars[GetRealmName()] = {}
				end
				if( not GarrisonDone_Vars[GetRealmName()][GetUnitName("player")]) then
					GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] = {}
				end
				newIndex = GarrisonDone_InTable(GarrisonDone_Vars[GetRealmName()][GetUnitName("player")], v.missionID, newIndex)
				if( not GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex] ) then
					GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex] = {}
				end
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].name = v.name
		--		GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].desciption = v.desciption
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].type = v.type
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].isRare = v.isRare
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].durationSeconds = v.durationSeconds
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].timeLeft = v.timeLeft
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].missionID = v.missionID
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].endTime = endTime
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].realm = GetRealmName()
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].character = GetUnitName("player")
                GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].class = UnitClass("player")
				if not GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].displayed then
					GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].displayed = false
				end
				if not GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].detailedTime then
					GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].detailedTime = detailedTime
				end
			end
		end
	end
end

            -- Let the Mission Table take control --
function GarrisonDone_InTable(tab, missionID, oldIndex)
	for i = 1, #tab, 1 do
		if(tab[i].missionID == missionID) then
			return i
		end
	end
	return oldIndex
end


function GarrisonDone_AltOnUpdate(self, elapsed)
	GarrisonDone_Update_Log = 0
	if GarrisonDone_Update_Log <= 0 then
		if GarrisonDone_Vars then
			for realm, v1 in pairs(GarrisonDone_Vars) do
				for character, v2 in pairs(v1) do
					for missionId, data in pairs(v2) do
						if ((data.endTime < time()) and (data.displayed == false)) then
							if not data.detailedTime then
								--GarrisonDone_UpdateData(data)Nope we don't --
							else
								data.displayed = true
								local color = "|cffE6CC80"
								if data.isRare == true then
									color = "|cff0070FF"
								end
								print(character.."-"..realm.." : "..color..data.name.." : |cffff0000completed")
							end
						end
					end
				end
			end
		end
	--	GarrisonDone_Update_Log = GarrisonDone_Update_Frequency
	end
end


                -- Load the Bars that will make up the list --
function GarrisonDoneAltsFrame_OnLoad(self)
	for i = 1, maxBars, 1 do
		    bar = CreateFrame("StatusBar", "GarrisonDone_bar_"..i, GarrisonDoneAltsScrollFrame)
		    bar:SetWidth(160)
		    bar:SetHeight(18)
		    bar:SetOrientation("HORIZONTAL")
            local backdrop = {
                bgFile = "Interface\AddOns\GarrisonDone\images\StatusBar7",  
                edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border",
                tile = false,
                edgeSize = 2,
                insets = {
                    left = 1,
                    right = 1,
                    top = 1,
                    bottom = 1
                }
            }
            bar:SetBackdrop(backdrop)
            bar:Raise()
            bar:SetBackdropColor(0, 0, 0, 0.4)
		    altMGDLabel = bar:CreateFontString("GarrisonDone_label_"..i, "ARTWORK", "GameFontNormalMed2")
		    altMGDLabel:SetTextHeight(12)
		    altMGDLabel:SetTextColor(0, 11, 44, 10)
		    altMGDLabel:SetPoint("LEFT", 10, 0, bar)
		    altMGDLabel:SetPoint("RIGHT", bar)
		    altMGDLabel:SetJustifyH("LEFT")
		    altMGDLabel:SetNonSpaceWrap(true)
		    bar:SetPoint("TOPLEFT", "GarrisonDoneAltsScrollFrame", 15, 18-20*(i))
		    bar:SetPoint("RIGHT", "GarrisonDoneAltsScrollFrame", 0, 0)
	end
end


            -- We have the Data now update the frame to show it - can we add a blank frame between names ?? --
function GarrisonDoneAltsFrame_OnUpdate(self, elapsed)
	    if not UnitAffectingCombat("player") then
        if GarrisonDoneAltsFrame:IsShown() == true then
	    GarrisonDoneAltsFrame_Update_Log = 0
		if GarrisonDoneAltsFrame_Update_Log <= 0 then
			local i = 0
			local b = 0 
				if GarrisonDone_Vars then
					for realm, v1 in pairs(GarrisonDone_Vars) do
						for character, v2 in pairs(v1) do
							for index, data in pairs(v2) do
								i = i + 1
								local offset = FauxScrollFrame_GetOffset(GarrisonDoneAltsScrollFrame)
								if i > offset and i <= (offset + maxBars) then
									b = b + 1
									local name = data.name
									local t = data.endTime - time()
									local bar, texture, label, altMGDLabel, object
									local missionID = data.missionID
									bar = _G["GarrisonDone_bar_"..b]
									altMGDLabel = _G["GarrisonDone_label_"..b]
                                    
									
                                    local color = "|cffE6CC80"
                                        -- Set Class Colors --
                                    if data.isRare ~= true then 
                                    altMGDLabel:SetPoint("LEFT", 10, 0, bar)
                                    if data.class == "Death Knight" then color = "|cffC41F3B"
                                    elseif data.class == "Druid" then color = "|cffFF7D0A"
                                    elseif data.class == "Hunter" then color = "|cffABD473"
                                    elseif data.class == "Mage" then color = "|cff69CCF0"
                                    elseif data.class == "Monk" then color = "|cff00FF96"
                                    elseif data.class == "Paladin" then color = "|cffF58CBA"
                                    elseif data.class == "Priest" then color = "|cffFFFFFF"
                                    elseif data.class == "Rogue" then color = "|cffFFF569"
                                    elseif data.class == "Shaman" then color = "|cff0070DE"
                                    elseif data.class == "Warlock" then color = "|cff9482C9"
                                    elseif data.class == "Warrior" then color = "|cffC79C6E"
                                        end
                                    end
                                        -- Change to Rare Blue for Rare Missions --
									if data.isRare == true then
                                    altMGDLabel:SetPoint("LEFT", 1, 0, bar)
                                    if data.class == "Death Knight" then color = "|cff0070FFR |cffC41F3B"
                                    elseif data.class == "Druid" then color = "|cff0070FFR |cffFF7D0A"
                                    elseif data.class == "Hunter" then color = "|cff0070FFR |cffABD473"
                                    elseif data.class == "Mage" then color = "|cff0070FFR |cff69CCF0"
                                    elseif data.class == "Monk" then color = "|cff0070FFR |cff00FF96"
                                    elseif data.class == "Paladin" then color = "|cff0070FFR |cffF58CBA"
                                    elseif data.class == "Priest" then color = "|cff0070FFR |cffFFFFFF"
                                    elseif data.class == "Rogue" then color = "|cff0070FFR |cffFFF569"
                                    elseif data.class == "Shaman" then color = "|cff0070FFR |cff0070DE"
                                    elseif data.class == "Warlock" then color = "|cff0070FFR |cff9482C9"
                                    elseif data.class == "Warrior" then color = "|cff0070FFR |cffC79C6E"
                                        end
                                    end
									if t > 60 then
										bar:SetValue(floor(t))
										altMGDLabel:SetText(string.format("%s: %02d:%02d", color..character.."-"..realm.."|cff00FAF6", floor(t/3600), floor(mod(t,3600)/60)))
									else
                                            -- When Seconds reach Zero the Mission is Done --
										if data.detailedTime == false and realm == GetRealmName() and character == GetUnitName("player") then
											GarrisonDone_UpdateData(data)
										end
										altMGDLabel:SetText(string.format("%s: |cff1EFF0CDone", color..character.."-"..realm..""))
									end
									bar:Show()
                                end								
							end 
						end
					end
				end  
			    FauxScrollFrame_Update(GarrisonDoneAltsScrollFrame, i, maxBars, 13)
			    if b <= maxBars then
				    b = b + 1
				for j = b,maxBars do
					_G["GarrisonDone_bar_"..j]:Hide()
				end
			end
		--	GarrisonDoneAltsFrame_Update_Log = GarrisonDoneAltsFrame_Update_Frequency
		    end
            if GarrisonDoneAltsFrame:IsShown() == true then
		        GarrisonDoneAltsScrollFrame:Show()
	        else
		        GarrisonDoneAltsFrame:Hide()
            end
        end
	end
end

            -- Update the Scroll Bar --
function GarrisonDoneAltsFrame_ScrollBar_Update()
	        GarrisonDoneAltsFrame_OnUpdate(nil, 2)
end

 

function GarrisonDoneAltsSort_OnLoad()
	        for i = 1, #sortOrders do
		    info = {
			    text = sortOrders[i].name;
			    value = sortOrders[i].value;
		    }
	end
end 


            

        -- OPTIONS TAB FRAME STARTS HERE --
          
        -- Auto Open Variable --
function GarrisonDone_Auto(self, MGD_Auto)
        local state = MGD_Auto:GetChecked()
	    if state then
		GarrisonDone_Varsc.auto = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Auto open is now ON");
        else
        GarrisonDone_Varsc.auto = false;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Auto Open is now OFF");
	end
end
        -- MGD Auto Open Tooltip --
function MGD_Auto_OnEnter(MGD_Auto)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Auto Opening")
    GameTooltip:AddLine("Toggles the Auto Open Function in Your Garrison.", 1, 1, 1)
    GameTooltip:AddLine("Will still Auto Open on Entering Town Hall", 1, 1, 1)
    GameTooltip:Show();
end


        -- Audio Warning Variable --
function GarrisonDone_Warn(self, MGD_Warn)
        local state = MGD_Warn:GetChecked()
	    if state then
		GarrisonDone_Varsc.warning = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Warning Sound is now ON");
        else
        GarrisonDone_Varsc.warning = false;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[Garrison Done] - |cff007fff Warning Sound is now OFF");
	end
end      
        -- MGD Audio Warning Tooltip --
function MGD_Warn_OnEnter(MGD_Warn)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Audio Raid Warning")
    GameTooltip:AddLine("Toggles the Raid Warning Function.", 1, 1, 1)
    GameTooltip:AddLine("Will still operate on Flight Path Open", 1, 1, 1)
    GameTooltip:Show();
end


        -- Mini Button Variable --     
function GarrisonDone_MiniButton(self, MGD_Mini)
        local state = MGD_Mini:GetChecked()
	    if state then
		GarrisonDone_Varsc.button = true;
        MGDButton:Show()
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Button is now ON");
	    else
		GarrisonDone_Varsc.button = false;
        MGDButton:Hide()
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Button is now OFF"); 
	end
end
        -- MGD Floating Button Tooltip --
function MGD_Mini_OnEnter(MGD_Mini)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Floating Button")
    GameTooltip:AddLine("Toggles the Garriosn Done floating Button", 1, 1, 1)
    GameTooltip:Show();
end


        -- Manual Window Control --
function GarrisonDone_Manual(self, MGD_Manual)
        local state = MGD_Manual:GetChecked()
	    if state then
		GarrisonDone_Varsc.manual = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Manual Window Control is ON");
	    else
		GarrisonDone_Varsc.manual = false;
    
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Manual Window Control is OFF"); 
	end
end
        -- Manual Window Control Tooltip --
function MGD_Manual_OnEnter(MGD_Manual)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Manual Window Control")
    GameTooltip:AddLine("Turns Off Auto Close", 1, 1, 1)
    GameTooltip:Show();
end


        -- Display Timer Variable --
function GarrisonDone_ChatTimer(self, MGD_Cdt)
        local state = MGD_Cdt:GetChecked()
	    if state then
		GarrisonDone_Varsc.disptimer = true;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Chat Display Timer is ON");
	    else
		GarrisonDone_Varsc.disptimer = false;
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Chat Display Timer is OFF"); 
	end
end
        -- MGD Hide Minimap Tooltip --
function MGD_Cdt_OnEnter(MGD_Cdt)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Chat Frame Display")
    GameTooltip:AddLine("Toggle 30 min Timer", 1, 1, 1)
    GameTooltip:AddLine("Timer lasts 5 hours.", 1, 1, 1)
    GameTooltip:AddLine("Certain Events will", 1, 1, 1)
    GameTooltip:AddLine("Restart the Timer.", 1, 1, 1)
    GameTooltip:Show();
end

        -- Hide Minimap Variable --
function GarrisonDone_Map(self, MGD_Map)
        local state = MGD_Map:GetChecked()
	    if state then
		GarrisonDone_Varsc.minimap.hide = true;
            icon:Hide("GarrisonDone");
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Hide Minimap Icon");
	    else
		GarrisonDone_Varsc.minimap.hide = false;
            icon:Show("GarrisonDone");
        DEFAULT_CHAT_FRAME:AddMessage("|cff00aa00[My Garrison] - |cff007fff Show Minimap Icon"); 
	end
end
        -- MGD Hide Minimap Tooltip --
function MGD_Map_OnEnter(MGD_Map)
    GameTooltip:SetOwner(GarrisonDoneFrame, "ANCHOR_TOPRIGHT")
    GameTooltip:SetText("Mini Map Icon")
    GameTooltip:AddLine("Hides the Minimap icon", 1, 1, 1)
    GameTooltip:AddLine("Function not yet available.", 1, 1, 1)
    GameTooltip:Show();
end

        
        
        -- Set Options Frame --
function GarrisonDone_OptionsOnShow(self)   
        if (GarrisonDoneOptEditFrame:IsShown()) then
        -- Alts Garrisons --
		GarrisonDoneOptPageName:SetText("Options Panel");
        -- Alt Players Name --
		MGDOptPageName:SetText("My Garrison is Done");
        -- Missions Complete and in Progress --  
		MGDOptCPageName:SetText("|cffFF8000Verison - |cff00aa00"..GarrisonDone_Version.."");
        MGD_Auto:SetChecked(GarrisonDone_Varsc.auto)
        MGD_Warn:SetChecked(GarrisonDone_Varsc.warning)
        MGD_Mini:SetChecked(GarrisonDone_Varsc.button)
        MGD_Manual:SetChecked(GarrisonDone_Varsc.manual)
        MGD_Map:SetChecked(GarrisonDone_Varsc.minimap.hide)
        MGD_Cdt:SetChecked(GarrisonDone_Varsc.disptimer)
    end
end
   
 
            
            
-- LDB LAUNCHER and MINIMAP LDB ICON --
            -- might change this to ldb display -- or better add Ldb Display --
local mgdldb = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("GarrisonDone", {
            type = "launcher",
	        text = "My Garrison",
            label = "My Garrison",
            tocname = "GarrisonDone",
            icon = "Interface\\AddOns\\GarrisonDone\\images\\MGDL.tga",
            OnClick = function(self, button, ...)
            if (button == "LeftButton") then
		    if GarrisonDoneFrame:IsShown() then
                GarrisonDoneFrame:Hide()
                else
                GarrisonDoneFrame:Show()
                end
       	    elseif (button == "RightButton") then
		    InterfaceOptionsFrame_OpenToCategory("GarrisonDone")
            InterfaceOptionsFrame_OpenToCategory("GarrisonDone")
                end    
            end,
            OnTooltipShow = function(tooltip)
                tooltip:AddLine('My Garrison is Done ('..GarrisonDone_Version..')')
                tooltip:AddLine('|cffffff00Left click for My Garrison Panel')
                tooltip:AddLine('|cffffff00Right Click to Move MGD Panel')
                tooltip:AddLine('|cffffff00Shift Right Click to Move MGD Button')
                tooltip:AddLine('|cffffff00Shift Right Click to Save MGD Panel')
            end,
        })      
                 
        
        

   -- INTERFACE OPTIONS MENU -- 
 
	local garrisondone = CreateFrame("Frame", "GarrisonDone", UIParent)
	garrisondone:Hide()
    garrisondone:IsResizable(true)
    garrisondone:SetMinResize(350,250)
	garrisondone.name = "My Garrison"
    garrisondone:SetBackdropColor(0, 0, 0, 1)
	garrisondone:SetWidth(250)
	garrisondone:SetHeight(400)
	garrisondone:SetPoint("CENTER", UIParent, "CENTER")
	InterfaceOptions_AddCategory(garrisondone)

	local title = garrisondone:CreateFontString("GarrisonDoneTitle", "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -20)
	title:SetText("My Garrison is Done ("..GarrisonDone_Version..")" )
 
    
    local mgdEditBox = CreateFrame("EditBox", "GarrisonDoneEditBox", garrisondone)
    mgdEditBox:SetPoint ("TOPLEFT",26,-42)
	mgdEditBox:EnableMouse(false)
	mgdEditBox:SetAutoFocus(false)
	mgdEditBox:SetFontObject(GameFontNormal)
	mgdEditBox:SetWidth(450)
	mgdEditBox:SetHeight(120)
    mgdEditBox:SetText("")
	mgdEditBox:Show()
    
    local mgdEditBoxText = mgdEditBox:CreateFontString("GarrisonDoneEditBoxTitle", "ARTWORK", "GameFontHighlight")
	mgdEditBoxText:SetPoint("BOTTOMLEFT", mgdEditBox, 5, -5)
	mgdEditBoxText:SetWidth(420)
	mgdEditBoxText:SetHeight(110)
    mgdEditBoxText:SetFontObject(GameFontHighlight)
    mgdEditBoxText:SetJustifyH("LEFT")
	mgdEditBoxText:SetText("Tracks how may Followers you have active, adjusts to LvL automatically (18/20 or 22/25). Monitors your missions so you Know how many are complete, How many are still in Progress, How many new Missions Waiting. Monitors your Followers Activities, How Many are assigned to Buildings, How many are in the Inn Drinking instead of being out on a Mission. Monitors your Herb and Mine nodes based on Building LvL and counts down as you Pick and Mine, (resets at Quest reset or over 24 Hours. Displays your Current Resources.")
    
    local mgdEditBoxText2 = mgdEditBox:CreateFontString("GarrisonDoneEditBoxTitle", "ARTWORK", "GameFontHighlight")
	mgdEditBoxText2:SetPoint("BOTTOMLEFT", mgdEditBox, 5, -115)
	mgdEditBoxText2:SetWidth(420)
	mgdEditBoxText2:SetHeight(110)
    mgdEditBoxText2:SetFontObject(GameFontHighlight)
    mgdEditBoxText2:SetJustifyH("LEFT")
	mgdEditBoxText2:SetText("Has it's own Floating button to put where you want it. Working Full LDB Launcher. |cff007fffJaxom of Hellfire EU")
    
    

